import { IPermissionsModel } from '@fleio-api/base-model/IPermissionsModel';
import { IIcon } from '@shared/ui/common/interfaces/icon';
import { ITitle } from '@objects-view/interfaces/card-data/card-title';
import { IObjectStatus } from '@objects-view/interfaces/object-status';
import { ObjectUIServiceBase } from '@objects-view/object-ui-service-base';
import { IAction } from '@objects-view/interfaces/actions/action';
import { RouterLinkAction } from '@objects-view/actions/router-link-action';
import { Router } from '@angular/router';
import { ConfigService } from '@shared/config/config.service';
import { IDataField } from '@objects-view/interfaces/card-data/data-field';
import { ApiCallAction, CallType } from '@objects-view/actions/api-call-action';
import { IDetailsTab } from '@objects-view/interfaces/details/details-tab';
import { DateFormatterPipe } from '@shared/ui/common/pipes/date-formatter.pipe';
import { IZoneModel } from '@fleio-api/openstack/zone/model/zone.model';
import { ZonesApiService } from '@fleio-api/openstack/zone/zones-api.service';
import { ZoneEditFormComponent } from './tabs/zone-edit-form/zone-edit-form.component';
import { CallbackAction } from '@objects-view/actions/callback-action';
import { ZoneDetailsOverviewComponent } from '@shared/common-tabs/openstack/zones/zone-details-overview/zone-details-overview.component';

export class ZoneUiService extends ObjectUIServiceBase<IZoneModel> {
  private readonly router: Router;
  private readonly config: ConfigService;
  private readonly zonesApiService: ZonesApiService;
  private readonly datePipe: DateFormatterPipe;


  constructor(
    zone: IZoneModel, permissions: IPermissionsModel, state: string,
    router: Router, config: ConfigService, zonesApiService: ZonesApiService
  ) {
    super(zone, permissions, state);
    this.router = router;
    this.config = config;
    this.zonesApiService = zonesApiService;
    this.datePipe = new DateFormatterPipe(this.config);
  }

  getIcon(): IIcon {
    return null;
  }

  getStatus(): IObjectStatus {
    return null;
  }

  getTitle(): ITitle {
    switch (this.state) {
      case 'edit':
        return {
          text: $localize`Edit ${this.object.name}`,
          subText: this.object.status.toLocaleUpperCase(),
        };

      case 'create':
        return {
          text: $localize`Create new zone`,
        };

      case 'details':
      default:
        return {
          text: `${this.object.name}`,
          subText: this.object.status.toLocaleUpperCase(),
        };
    }
  }

  getActions(): IAction[] {
    const actions: IAction[] = [];

    actions.push(new RouterLinkAction({
        icon: {name: 'edit', class: 'fl-icons'},
        name: $localize`Edit`,
        tooltip: $localize`Edit zone`,
        routerUrl: this.config.getPanelUrl(`openstack/zones/${this.object.id}/edit`),
        router: this.router,
        noPermissions: !this.permissions['dns.update'],
      }
    ));

    actions.push(new ApiCallAction(
      {
        object: this.object,
        icon: {name: 'delete'},
        name: $localize`Delete`,
        tooltip: $localize`Delete zone`,
        confirmOptions: {
          confirm: true,
          title: $localize`Delete zone`,
          message: $localize`Are you sure you want to delete zone ${this.object.name}?`,
        },
        successMessage: $localize`Zone deleted`,
        errorMessage: $localize`Failed to delete zone, check logs for details`,
        apiService: this.zonesApiService,
        callType: CallType.Delete,
        refreshAfterExecute: false,
        redirectAfterExecute: true,
        redirectUrl: this.config.getPanelUrl('openstack/zones'),
        noPermissions: !this.permissions['dns.destroy'],
      }
    ));

    return actions;
  }

  getDetailsActions(): IAction[] {
    const actions = [];

    switch (this.state) {
      case 'create':
        actions.push(new RouterLinkAction({
            name: $localize`Cancel`,
            routerUrl: this.config.getPrevUrl(`openstack/zones`),
            router: this.router,
          }
        ));
        actions.push(new CallbackAction({name: $localize`Create`}));
        break;
      case 'edit':
        actions.push(new RouterLinkAction({
            name: $localize`Cancel`,
            routerUrl: this.config.getPrevUrl(`openstack/zones`),
            router: this.router,
          }
        ));
        actions.push(new CallbackAction({name: $localize`Save`}));
        break;
      default:
        break;
    }

    return actions;
  }

  getDetailsLink(): string {
    return this.config.getPanelUrl(`openstack/zones/${this.object.id}`);
  }

  getCardFields(): IDataField[] {
    const fields = [
      {
        name: $localize`Created at`,
        value: this.datePipe.transform(this.object.created_at),
        title: this.datePipe.getTitleAttributeValue(this.object.created_at),
      },
      {
        name: $localize`Email`,
        value: this.object.email,
      },
    ];

    return fields;
  }

  getTabs(): IDetailsTab[] {
    switch (this.state) {
      case 'details':
        return [
          {
            tabName: $localize`Overview`,
            tabIdentifier: 'overview',
            component: ZoneDetailsOverviewComponent,
          },
        ];
      case 'create':
        return [
          {
            tabName: $localize`Create`,
            tabIdentifier: 'create',
            component: ZoneEditFormComponent,
          },
        ];
      case 'edit':
        return [
          {
            tabName: $localize`Edit zone`,
            tabIdentifier: 'edit-zone',
            component: ZoneEditFormComponent,
          },
        ];
    }
  }

  getCardTags(): string[] {
    return [];
  }
}
